﻿Type=Class
Version=3.2
@EndOfDesignText@
'Class module

'code to put in main
'************************************************************
' declare scale as float in process_globals
' declare your msg object in globals

'Sub Activity_Resume
'scale1 = 1.0 ' just for the font, does not relate to the class scale
'mymsg.Initialize("Main", "mymsg", Colors.yellow ,Colors.yellow, 24*scale1, Colors.White, 20*scale1 ,Colors.Yellow, Activity.width,Activity.height)
'Activity.AddView(mymsg.AsView,0,0,100%x,100%y)
'end sub

'*************************************************************************


Sub Class_Globals
	Private DialogBG,frame , p, line  As Panel	
	Private btn(3) As Button
	Private titlelbl, msglbl As Label
	Private result As Int = 0
	Private DefaultResult As Int = 0
	Private scale, SF As Float 
	Private event As String
	Private AW, AH As Int
	Private Phone As Phone
	Private Timer1 As Timer
End Sub

'Initializes the object.
Public Sub Initialize( Eventname As String, TitleSize As Int, MsgSize As Int, ActivityWidth As Int, ActivityHeight As Int )

	AW = ActivityWidth
	AH = ActivityHeight
	Dim clr(2) As Int
	Dim dw As GradientDrawable

	SF =  Max(AW,AH)/800 
	scale = SF
	event = Eventname

	DialogBG.Initialize("bg")
	frame.Initialize("")
	p.Initialize("")
	line.Initialize("")
	titlelbl.Initialize("")
	msglbl.Initialize("")

	DialogBG.Color = Colors.ARGB(255,0,0,0)
	frame.Color = Colors.ARGB(255,139,0,0)
	p.Color = Colors.ARGB(255,255,248,220)
	titlelbl.TextSize = TitleSize * scale
	titlelbl.TextColor = Colors.Black
	titlelbl.Gravity = Gravity.CENTER
	msglbl.TextSize = MsgSize * scale
	msglbl.TextColor = Colors.Black
	msglbl.Gravity = Gravity.CENTER
	line.Color = Colors.Black
	clr(0) = Colors.Black
	clr(1) = Colors.Black
	dw.Initialize("TOP_BOTTOM",clr)
	dw.CornerRadius = 5dip
	For i = 0 To 2
		btn(i).Initialize("button")
		btn(i).background = dw
		btn(i).TextSize = MsgSize*scale
		btn(i).Textcolor = Colors.White
		
	Next
	btn(0).Tag = DialogResponse.POSITIVE
	btn(1).Tag = DialogResponse.CANCEL
	btn(2).Tag = DialogResponse.NEGATIVE

	DialogBG.AddView(frame,AW/2-130dip*scale, AH/2-105dip*scale, 250dip*scale, 210dip*scale)
	frame.AddView(p,5dip*scale, 5dip*scale,240dip*scale,200dip*scale)
	p.AddView(titlelbl,5dip*scale,5dip*scale,235dip*scale,40dip*scale)
	p.AddView(line,0,50dip*scale,p.Width,3dip*scale)
	p.AddView(msglbl,5dip*scale,60dip*scale,230dip*scale,80dip*scale)
	p.AddView(btn(0),5dip*scale,145dip*scale,73dip*scale,50dip*scale)
	p.AddView(btn(1),83dip*scale,145dip*scale,74dip*scale,50dip*scale)
	p.AddView(btn(2),162dip*scale,145dip*scale,73dip*scale,50dip*scale)
	DialogBG.Visible = False
End Sub

'Increase or Decrease the dialog size, but keeps it centered. SizeFactor = 1 is no change.
Public Sub SetScale(SizeFactor As Float)
	scale = SF * SizeFactor
	frame.SetLayout(AW/2-130dip*scale, AH/2-105dip*scale, 250dip*scale, 210dip*scale)
	p.SetLayout(5dip*scale, 5dip*scale,240dip*scale,200dip*scale)
	titlelbl.SetLayout(5dip*scale,5dip*scale,235dip*scale,40dip*scale)
	line.SetLayout(0,50dip*scale,p.Width,3dip*scale)
	msglbl.SetLayout(5dip*scale,60dip*scale,230dip*scale,80dip*scale)
	btn(0).SetLayout(5dip*scale,145dip*scale,73dip*scale,50dip*scale)
	btn(1).SetLayout(83dip*scale,145dip*scale,74dip*scale,50dip*scale)
	btn(2).SetLayout(162dip*scale,145dip*scale,73dip*scale,50dip*scale)
End Sub

'If midtext or righttext are passed as "" - the buttons will not show.
Public Sub Show(Title As String, Text As String, LeftText As String, MidText As String, RightText As String, Timeout As Int, TimedResult As Int, SizeFactor As Float)

	SetScale( SizeFactor )
	titlelbl.Text = Title
	msglbl.Text = Text
	btn(0).Text = LeftText

	If MidText = "" Then
		btn(1).Visible = False
		If RightText = "" Then
			btn(2).Visible = False
			btn(0).Left = 65dip*scale
			btn(0).Width = 110dip*scale
		Else
			btn(0).SetLayout(5dip*scale,145dip*scale,110dip*scale,50dip*scale)
			btn(2).SetLayout(125dip*scale,145dip*scale,110dip*scale,50dip*scale)
			btn(2).Text = RightText
			btn(2).Visible = True
		End If
	Else
		btn(0).SetLayout(5dip*scale,145dip*scale,73dip*scale,50dip*scale)
		btn(1).SetLayout(83dip*scale,145dip*scale,74dip*scale,50dip*scale)
		btn(2).SetLayout(162dip*scale,145dip*scale,73dip*scale,50dip*scale)
		btn(1).Text = MidText
		btn(2).Text = RightText
		btn(1).Visible = True
		btn(2).Visible = True
	End If 

	DialogBG.Visible = True
	DialogBG.BringToFront

	If AW>AH Then 
		Phone.SetScreenOrientation(0)
	Else 
		Phone.SetScreenOrientation(1)
	End If
	result = 0
	If Timeout > 0 Then
		DefaultResult = TimedResult
		Timer1.Initialize("Timer1", Timeout)
		Timer1.Enabled = True
	End If
	Do While result = 0
		DoEvents
	Loop
	If Timer1.Enabled = True Then
		Timer1.Enabled = False
	End If
	Phone.SetScreenOrientation(-1)
	Return result

End Sub

Public Sub AsView As View
	Return DialogBG
End Sub

Private Sub button_click
	Dim B As Button
	B = Sender
	result = B.Tag
	DialogBG.Visible = False
	DialogBG.SendToBack
End Sub

Sub Timer1_Tick
	result = DefaultResult
	DialogBG.Visible = False
	DialogBG.SendToBack
End Sub


